#include <iostream>
#include <fstream>
#include <string.h>
#include <stdlib.h>
using namespace std;

const int MAXS = 100;
const int MAXL = 5;
const int MAXRIP = 3;
const int MAXPOS = 2;

struct Data {
  int giorno;
  int mese;
  int anno;
};

struct Libro {
  char tit[MAXS];
  char aut[MAXS];
  int pag;
  Data pubbl;
};

struct PilaLibri {
  Libro stack[MAXL];
  int top;
};


typedef PilaLibri Scaffale[MAXRIP][MAXPOS];

bool sposta(Scaffale s, int ripsrc, int possrc, int ripdst, int posdst);
bool piuVecchio(const Scaffale s, Libro* pl);
bool salvaOrd(const Scaffale s, const char f[]);
bool cercaAutore(const Scaffale s, int rip, int pos, const char a[]);
bool inserisciLibro(Scaffale s, const Libro l, int rip);

void init(PilaLibri* pl) {
  pl->top = -1;
}

void init(Scaffale ps) {
  for(int i=0; i<MAXRIP; i++) {
    for(int j=0; j<MAXPOS; j++) {
      init(&ps[i][j]);   
    }
  }
}

void stampaLibro(Libro l){
  cout << l.tit << ", " << l.aut 
       << ", p. " << l.pag << ", " 
       << l.pubbl.giorno << '/' << l.pubbl.mese << '/' << l.pubbl.anno << endl;
}

void stampaPila(PilaLibri pl) {
  for(int i=pl.top; i>=0; i--) {
    stampaLibro(pl.stack[i]);
  }
}

void stampa(Scaffale ps) {
  for(int i=0; i<MAXRIP; i++) {
    for(int j=0; j<MAXPOS; j++) {
      cout << "Ripiano: " << i << ", posizione: " << j << endl;
      stampaPila(ps[i][j]);
    }
    cout << "-----------------------" << endl;
  }
}

void menu(){
  cout << "1) inserisci libro" << endl;
  cout << "2) cerca autore" << endl;
  cout << "3) piu' vecchio" << endl;
  cout << "4) salva ord" << endl;
  cout << "5) sposta" << endl;
  cout << "6) stampa" << endl;
  cout << "7) esci" << endl;
}

Data leggiData(){
  Data d;
  cout << "Inserisci anno: "; 
  cin >> d.anno;
  cout << "Inserisci mese: "; 
  cin >> d.mese;
  cout << "Inserisci giorno: "; 
  cin >> d.giorno;
  return d;
}

Libro leggiLibro(){
  Libro l;
  cout << "Inserisci titolo (una sola parola): ";
  cin >> l.tit;
  cout << "Inserici autore (una sola parola): ";
  cin >> l.aut;
  cout << "Inserisci numero pagine: "; 
  cin >> l.pag;
  l.pubbl = leggiData();
  return l;
}


int main(){
  Scaffale scaff;
  init(scaff);

  char c;
  Libro l;
  int nr, np, nr2, np2;
  bool r;
  char au[MAXS];
  while(true) {
    menu();
    cin >> c;
    switch(c) {
      case '1':
        l = leggiLibro();
        cout << "Quale ripiano? ";
        cin >> nr; 
        r = inserisciLibro(scaff, l, nr);
        if(r) cout << "Libro inserito nel ripiano richiesto" << endl;
        else cout << "Libro non inserito" << endl;
        break;
      case '2':
        cout << "Inserisci autore: ";
        cin >> au;
        cout << "Quale ripiano? ";
        cin >> nr; 
        cout << "Quale posizione? ";
        cin >> np; 
        r = cercaAutore(scaff, nr, np, au);
        if(r) cout << "Autore presente" << endl;
        else cout << "Autore non presente" << endl;
        break;  
      case '3':
        r = piuVecchio(scaff, &l);
        if(r) {
          cout << "Il libro piu' vecchio e': " << endl;
          stampaLibro(l);
        } else cout << "Non ci sono libri" << endl;
        break;
      case '4':
        r = salvaOrd(scaff, "prova.txt");
        if(r) {
          cout << "Contenuto del file prova.txt:" << endl;
          system("type prova.txt"); 
        } else {
          cout << "Salvataggio non riuscito" << endl;
        }
        break;
      case '5':
        cout << "Da" << endl;
        cout << "Quale ripiano? ";
        cin >> nr; 
        cout << "Quale posizione? ";
        cin >> np; 
        cout << "A" << endl;
        cout << "Quale ripiano? ";
        cin >> nr2; 
        cout << "Quale posizione? ";
        cin >> np2; 
        r = sposta(scaff, nr, np, nr2, np2);
        if(r) cout << "Spostamento eseguito" << endl;
        else cout << "Spostamento non eseguito" << endl;
        break;  
      case '6':
        stampa(scaff);
        break;
      case '7':
        return 0;
      default:
        cout << "Scelta inesistente" << endl; 
    }
  }
}
