#include <iostream>
#include <fstream>
#include <string.h>
using namespace std;

const int MAXS = 100;
const int MAXL = 5;
const int MAXRIP = 3;
const int MAXPOS = 2;

struct Data {
  int giorno;
  int mese;
  int anno;
};

struct Libro {
  char tit[MAXS];
  char aut[MAXS];
  int pag;
  Data pubbl;
};

struct PilaLibri {
  Libro stack[MAXL];
  int top;
};


typedef PilaLibri Scaffale[MAXRIP][MAXPOS];

bool full(const PilaLibri* pp) {
  if(pp->top == MAXL-1) return true;
  return false;
}

bool empty(const PilaLibri* pp) {
  if(pp->top == -1) return true;
  return false;
}

bool push(PilaLibri* pp, Libro l) {
  if(full(pp)) return false;
  pp->top = pp->top + 1;
  pp->stack[pp->top] = l;
  return true;
}

bool pop(PilaLibri* pp, Libro* pl) {
  if(empty(pp)) return false;
  *pl = pp->stack[pp->top];
  pp->top = pp->top - 1;
  return true;
}


bool sposta(Scaffale s, int ripsrc, int possrc, int ripdst, int posdst) {
  if(!empty(&s[ripdst][posdst]) || empty(&s[ripsrc][possrc])) return false;
  do {
    Libro tmp;
    pop(&s[ripsrc][possrc], &tmp);
    push(&s[ripdst][posdst], tmp);
  } while(!empty(&s[ripsrc][possrc]));
  return true;
}

int confronta(const Data l1, const Data l2) {
  if(l1.anno != l2.anno) return l1.anno - l2.anno;
  if(l1.mese != l2.mese) return l1.mese - l2.mese;
  return l1.giorno - l2.giorno;
}

bool piuVecchio(const Scaffale s, Libro* pl){
  Libro pv;
  bool primo = true;
  for(int i=0; i<MAXRIP; i++) {
    for(int j=0; j<MAXPOS; j++) {
      for(int k=0; k<=s[i][j].top; k++) {
        if(primo) {
          primo = false;
          pv = s[i][j].stack[k];
        } else {
          if(confronta(s[i][j].stack[k].pubbl, pv.pubbl) < 0) 
            pv = s[i][j].stack[k];
        }
      }
    }
  }
  if(primo) return false;
  *pl = pv;
  return true;
}

void ordina(Libro v[], int n) {
  for(int i=0; i<n-1; i++) {
    int index = i;
    for(int j=i+1; j<n; j++) {
      if(v[j].pag > v[index].pag)
        index = j;
    }
    Libro l;
    l = v[index];
    v[index] = v[i];
    v[i] = l;
  } 
}

bool salvaOrd(const Scaffale s, const char f[]) {
  Libro tmp[MAXRIP*MAXPOS*MAXL];
  int conta = 0;
  for(int i=0; i<MAXRIP; i++) {
    for(int j=0; j<MAXPOS; j++) {
      for(int k=0; k<=s[i][j].top; k++) {
        tmp[conta++] = s[i][j].stack[k];
      }
    }
  } 
  ordina(tmp, conta);
  fstream fs;
  fs.open(f, ios::out);
  if(!fs) return false;
  for(int i=0; i<conta; i++) 
    fs << tmp[i].tit << ", "<< tmp[i].aut << ", " << tmp[i].pubbl.giorno << '/' << tmp[i].pubbl.mese << '/' << tmp[i].pubbl.anno << ", "<< tmp[i].pag << endl;
  return true;
}

bool cercaAutore(const Scaffale s, int rip, int pos, const char a[]) {
  for(int k=0; k<=s[rip][pos].top; k++) {
    if(strcmp(s[rip][pos].stack[k].aut, a) == 0)
      return true;
  }
  return false;
}

bool inserisciLibro(Scaffale s, const Libro l, int rip) {
  int p = 0;
  do {
    if(push(&s[rip][p], l))
      return true;
    p++;
  } while(p<MAXPOS);
  return false;
}
